/*****************************************************************************
 *
 *     Author: Xilinx, Inc.
 *
 *     This text contains proprietary, confidential information of
 *     Xilinx, Inc. , is distributed by under license from Xilinx,
 *     Inc., and may be used, copied and/or disclosed only pursuant to
 *     the terms of a valid license agreement with Xilinx, Inc.
 *
 *     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
 *     AS A COURTESY TO YOU, SOLELY FOR USE IN DEVELOPING PROGRAMS AND
 *     SOLUTIONS FOR XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE,
 *     OR INFORMATION AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE,
 *     APPLICATION OR STANDARD, XILINX IS MAKING NO REPRESENTATION
 *     THAT THIS IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
 *     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
 *     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
 *     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
 *     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
 *     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
 *     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *     FOR A PARTICULAR PURPOSE.
 *
 *     Xilinx products are not intended for use in life support appliances,
 *     devices, or systems. Use in such applications is expressly prohibited.
 *
 *     (c) Copyright 2013 Xilinx Inc.
 *     All rights reserved.
 *
 *****************************************************************************/

/********************************************
 * UTIA AV CR, v.v.i
 * Signal Processing Department
 * Pod Vodarenskou vezi 4
 * 182 08 Prague
 * Czech Republic
 * web: http://zs.utia.cas.cz
 *
 * Filename: main.c
 * Date: 26.03.2016
 * Authors:
 * Jiri Kadlec <kadlec@utia.cas.cz>
 * Zdenek Pohl <xpohl@utia.cas.cz>
 * Lukas Kohout <kohoutl@utia.cas.cz>
 * Description:
 *
 * Changelog:
 *
 *
 ********************************************/


#include <stdio.h>
#include "frame_size.h"
#include "hw_motion_detect.h"


unsigned short yc_data_prev1[NUMROWS*NUMCOLS];
unsigned short yc_data_in1[NUMROWS*NUMCOLS];
unsigned short yc_out_tmp11[NUMROWS*NUMCOLS];
unsigned short yc_out_tmp12[NUMROWS*NUMCOLS];
unsigned short yc_out_tmp13[NUMROWS*NUMCOLS];
unsigned short yc_out_tmp14[NUMROWS*NUMCOLS];
unsigned char sobel_curr1[NUMROWS*NUMCOLS];
unsigned char sobel_prev1[NUMROWS*NUMCOLS];
unsigned char motion_image_tmp11[NUMROWS*NUMCOLS];
unsigned char motion_image_tmp12[NUMROWS*NUMCOLS];

unsigned short yc_data_prev2[NUMROWS*NUMCOLS];
unsigned short yc_data_in2[NUMROWS*NUMCOLS];
unsigned short yc_out_tmp21[NUMROWS*NUMCOLS];
unsigned short yc_out_tmp22[NUMROWS*NUMCOLS];
unsigned short yc_out_tmp23[NUMROWS*NUMCOLS];
unsigned short yc_out_tmp24[NUMROWS*NUMCOLS];
unsigned char sobel_curr2[NUMROWS*NUMCOLS];
unsigned char sobel_prev2[NUMROWS*NUMCOLS];
unsigned char motion_image_tmp21[NUMROWS*NUMCOLS];
unsigned char motion_image_tmp22[NUMROWS*NUMCOLS];

void img_process(unsigned short *rgb_data_prev1, unsigned short *rgb_data_in1, unsigned short *rgb_data_out1, unsigned short *rgb_data_prev2, unsigned short *rgb_data_in2, unsigned short *rgb_data_out2, int param0, int param1, int param2)
{
    unsigned char pass_through1;
    unsigned char pass_through2;
    unsigned char threshold1;
    unsigned char threshold2;
    threshold1 = 100;
    threshold2 = 100;
    pass_through1 = 0; // always force combo
    pass_through2 = 0; // always force combo

    _p0_pad1_1(rgb_data_prev1, yc_data_prev1);
    _p0_pad1_0(rgb_data_in1, yc_data_in1);
    _p0_sobel_filter_pass1_0(yc_data_in1, sobel_curr1, yc_out_tmp11);
    _p0_sobel_filter1_0(yc_data_prev1, sobel_prev1);
    _p0_diff_image1_0(sobel_curr1, sobel_prev1, yc_out_tmp11, yc_out_tmp12, motion_image_tmp11);
    _p0_median_char_filter_pass1_0(threshold1, motion_image_tmp11, yc_out_tmp12, motion_image_tmp12, yc_out_tmp13);
    _p0_combo_image1_0(pass_through1, motion_image_tmp12, yc_out_tmp13, yc_out_tmp14);
    _p0_ext1_0(yc_out_tmp14, rgb_data_out1);

    _p0_pad2_1(rgb_data_prev2, yc_data_prev2);
    _p0_pad2_0(rgb_data_in2, yc_data_in2);
    _p0_sobel_filter_pass2_0(yc_data_in2, sobel_curr2, yc_out_tmp21);
    _p0_sobel_filter2_0(yc_data_prev2, sobel_prev2);
    _p0_diff_image2_0(sobel_curr2, sobel_prev2, yc_out_tmp21, yc_out_tmp22, motion_image_tmp21);
    _p0_median_char_filter_pass2_0(threshold2, motion_image_tmp21, yc_out_tmp22, motion_image_tmp22, yc_out_tmp23);
    _p0_combo_image2_0(pass_through2, motion_image_tmp22, yc_out_tmp23, yc_out_tmp24);
    _p0_ext2_0(yc_out_tmp24, rgb_data_out2);
}


